#include "Flappy_bird.h"

int time_getTicks()
{
	asm("mov.l syscall_adress, r2\n"
	    "mov.l getTicks, r0\n"
	    "jmp @r2\n"
	    "nop\n"
	    "syscall_adress: .long 0x80020070\n"
	    "getTicks: .long 0x02C1");
}

int IsEmulated() // savoir si on est sous émuateur
{
   int emul = *(unsigned char*)P11DR;
   if (emul==0x0000) return EMULATEUR; // on pc
   else return CALCULATRICE;// on calc
}

void Key_Down_Up(int basic_keycode)
{
	while(key_down(basic_keycode));
    while(!key_down(basic_keycode));
}

void Rectangle(int x0, int y0, int x1, int y1, color_t color)
{
	CL_Line(x0, y0, x0, y1, color);
	CL_Line(x0, y0, x1, y0, color);
	CL_Line(x1, y1, x0, y1, color);
	CL_Line(x1, y1, x1, y0, color);
}

double floor(double x)
{
	int partieEntiere = x;

	if (x>0)
		return partieEntiere;

	if ((double)partieEntiere == x)
		return x;

	return partieEntiere - 1;
}

void print_score(int score)
{
	if(score<0) score=0;
	int a=0, nombre_chiffre=1+(score>9)+(score>99)+(score>999)+(score>9999)+(score>99999);
	for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
	{
		CopySprite_Palette_Alpha(sprite_number[score%10], sprite_number_palette, 200-7*a, 20, 7, 10);
		score= floor((double) (score/10));
		a++;
	}
}

int pause()
{
	int choix = 0, key=0, compteur;
	while(key!=K_EXE)
	{
		if(compteur>24) compteur=0;
		compteur++;
		key=GetKeyNB();
		if(key==K_UP) choix=0;//come back to game
		if(key==K_DOWN) choix=1;// menu
		CopySprite_Palette(Pause, sprite_menu_palette, 172, 80, 40, 14);
		CopySprite_Palette(resume, sprite_menu_palette, 172, 100, 40, 14);
		CopySprite_Palette(menusss, sprite_menu_palette, 172, 120, 40, 14);
		Rectangle(173, 101+20*choix, 210, 111+20*choix, COLOR_LIGHTSTEELBLUE*(compteur<=11)+COLOR_WHITE*(compteur>=12));
		Bdisp_PutDisp_DD();
		OS_InnerWait_ms(30);
	}
	return choix;
}

void view_score(int best_score, int score, int mode)
{
	int nombre_chiffre=0, a=0, b=0, c=0;
	//affiche score
	CopySprite_Palette(scoresss, sprite_menu_palette, 135, 100, 113, 58);
	b=0, c=best_score, nombre_chiffre=1+(c>9)+(c>99)+(c>999)+(c>9999)+(c>99999);
	for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
	{
		CopySprite_Palette_Alpha(litle_sprite_number[c%10], sprite_number_palette, 231-7*b, 140, 6, 7);
		c=floor((double) (c/10));
		b++;
	}
	if(mode==MAKE)
	{
		SaveVRAM_1();
		for(a=0; a<=score; a++)
		{
			LoadVRAM_1();
			b=0, c=a,nombre_chiffre=1+(a>9)+(a>99)+(a>999)+(a>9999)+(a>99999);
			for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
			{
				CopySprite_Palette_Alpha(litle_sprite_number[c%10], sprite_number_palette, 231-7*b, 119, 6, 7);
				c=floor((double) (c/10));
				b++;
			}
			Bdisp_PutDisp_DD();
		}
	}
	b=0, c=score,nombre_chiffre=1+(score>9)+(score>99)+(score>999)+(score>9999)+(score>99999);
	CopySprite_Palette(scoresss, sprite_menu_palette, 135, 100, 113, 58);
	for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
	{
		CopySprite_Palette_Alpha(litle_sprite_number[c%10], sprite_number_palette, 231-7*b, 119, 6, 7);
		c=floor((double) (c/10));
		b++;
	}
	if(score>=best_score)
	{
		b=0, c=score,nombre_chiffre=1+(score>9)+(score>99)+(score>999)+(score>9999)+(score>99999);
		for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
		{
			CopySprite_Palette_Alpha(litle_sprite_number[c%10], sprite_number_palette, 231-7*b, 140, 6, 7);
			c=floor((double) (c/10));
			b++;
		}
	}
	else
	{
		b=0, c=best_score,nombre_chiffre=1+(c>9)+(c>99)+(c>999)+(c>9999)+(c>99999);
		for(nombre_chiffre; nombre_chiffre; nombre_chiffre--)
		{
			CopySprite_Palette_Alpha(litle_sprite_number[c%10], sprite_number_palette, 231-7*b, 140, 6, 7);
			c=floor((double) (c/10));
			b++;
		}
	}
	Bdisp_PutDisp_DD();
}

int game(int Nombre_oiseau)
{
	int score=-2, lose=0, a=0, b=0, c=0, key=0, compteur=0, appuis=1;
	int altitude=100, gravite=9.810, force=25, vitesse=0, monte=0; 
	unsigned char map[NOMBRE_TUBE]={0, 0, 0, 0, 0};//stokage tete de haut
	for(a=0; a<NOMBRE_TUBE; a++)
	{
		if(a>2) map[a]=(rand()%88+16);
	}
	while(lose==0)
	{
		compteur+=2;
		if(compteur>84)
		{
			compteur=0;
			for(a=0; a<(NOMBRE_TUBE-1); a++)
			{
				map[a]=map[a+1];
			}
			map[4]=rand()%88+16;
		}
		if(compteur==64) score++;
		key=GetKeyNB();
		monte=0;
		if((appuis<=6) && ((key==K_EXE) || (key==K_SHIFT) || (key==K_F1) || (key==K_UP) || (key==K_0))) monte=1, appuis++;
		if((key!=K_EXE) && (key!=K_SHIFT) && (key!=K_F1) && (key!=K_UP) && (key!=K_0)) appuis=0;
		vitesse=vitesse+gravite-force*monte;
		if(vitesse>60) vitesse=60;
		if(vitesse<-60) vitesse=-60;
		altitude+=vitesse/10;
		//if(key==K_UP) altitude--;
		//if(key==K_DOWN) altitude++;
		if(altitude>148) altitude=148;
		if(altitude<0) altitude=0;
		if((key==K_MINUS) || (key==K_ALPHA) || (key==K_F6) || (key==K_EXIT) ) if(pause()==1) lose=1;
		if((altitude>=148) || ((map[1]!=0) && ((((compteur>=38) && (compteur<=78)) && ((altitude<map[1]) || (altitude>((map[1])+28))))))) lose=1;
		CopySprite_Palette(fond, fond_palette, DECALAGE_SCREEN, 0, SCREEN_LARGEUR, 216);
		for(a=0; a<4; a++)
		{
			b=map[a];
			if(b!=0)
			{
				for(c=0  ; c<(b-11); c++) CopySprite_Palette_Alpha(tube, sprite_decor_palette, a*84-compteur+DECALAGE, c, 24, 1);
				for(c=160; c>(b+51); c--) CopySprite_Palette_Alpha(tube, sprite_decor_palette, a*84-compteur+DECALAGE, c, 24, 1);
				CopySprite_Palette(teteB, sprite_decor_palette, a*84-compteur+DECALAGE-1, b-12, 26, 12);
				CopySprite_Palette(teteH, sprite_decor_palette, a*84-compteur+DECALAGE-1, b+40, 26, 12);
			}
		}
		for(a=0; a<44; a++) CopySprite_Palette(barre, sprite_decor_palette, 7*a-compteur%7+DECALAGE_SCREEN, 160, 7, 7);
		print_score(score);
		CopySprite_Palette_Alpha(sprite_bird[3*Nombre_oiseau+table[(compteur/2)%4]], sprite_bird_palette[3*Nombre_oiseau+table[(compteur/2)%4]], 130, altitude, 17, 12);
		CL_Filled_Rectangle(0, 0, 41, 216, COLOR_BLACK);
		CL_Filled_Rectangle(342, 0, 384, 216, COLOR_BLACK);
		Bdisp_PutDisp_DD();
	}
	//animations perdu
	while(altitude<=148)
	{
		altitude+=2;
		CopySprite_Palette(fond, fond_palette, DECALAGE_SCREEN, 0, SCREEN_LARGEUR, 216);
		for(a=0; a<4; a++)
		{
			b=map[a];
			if(b!=0)
			{
				for(c=0  ; c<(b-11); c++) CopySprite_Palette_Alpha(tube, sprite_decor_palette, a*84-compteur+DECALAGE, c, 24, 1);
				for(c=160; c>(b+51); c--) CopySprite_Palette_Alpha(tube, sprite_decor_palette, a*84-compteur+DECALAGE, c, 24, 1);
				CopySprite_Palette(teteB, sprite_decor_palette, a*84-compteur+DECALAGE-1, b-12, 26, 12);
				CopySprite_Palette(teteH, sprite_decor_palette, a*84-compteur+DECALAGE-1, b+40, 26, 12);
			}
		}
		for(a=0; a<44; a++) CopySprite_Palette(barre, sprite_decor_palette, 7*a-compteur%7+DECALAGE_SCREEN, 160, 7, 7);
		CopySprite_Palette_Alpha(sprite_bird[3*Nombre_oiseau], sprite_bird_palette[3*Nombre_oiseau], 130, altitude, 17, 12);
		CopySprite_Palette_Alpha(gameover, sprite_menu_palette, 145, 60, 93, 19);
		CL_Filled_Rectangle(0, 0, 41, 216, COLOR_BLACK);
		CL_Filled_Rectangle(342, 0, 384, 216, COLOR_BLACK);
		Bdisp_PutDisp_DD();
	}
	Sleep(500);
	if(score<0) score=0;
	return score;
}

int menu(int best_score)
{
	int exit=0, key=0, compteur=0, choix=0, a=0, score=0, passe=0, Nombre_oiseau=0, b=1;
	while(exit!=3)
	{
		key=GetKeyNB();
		if(key!=0) while(key_down(key));
		exit=0, choix=0, key=0;
		while(exit==0)
		{
			if(compteur>48) compteur=0;
			compteur++;
			key=GetKeyNB();
			if(b==1)
			{
				if(key==K_F1) Nombre_oiseau=rand()%14, b=0;
				if((key==K_EXE) || (key==K_SHIFT)) exit=1, b=0;
				if(key==K_MENU) exit=3, b=0;
				if(key==K_RIGHT)choix=1, b=0;
				if(key==K_LEFT) choix=0, b=0;
			}
			if(key==0) b=1;
			CopySprite_Palette(fond, fond_palette, DECALAGE_SCREEN, 0, SCREEN_LARGEUR, 216);
			CopySprite_Palette_Alpha(title, sprite_menu_palette, 144, 60, 96, 22);
			CopySprite_Palette_Alpha(start, sprite_menu_palette, 115, 145, 40, 14);
			CopySprite_Palette_Alpha(scorebouton, sprite_menu_palette, 230, 145, 40, 14);
			CopySprite_Palette_Alpha(sprite_bird[3*Nombre_oiseau+table[(compteur/2)%4]], sprite_bird_palette[3*Nombre_oiseau+table[(compteur/2)%4]], 250, 63, 17, 12);
			for(a=0; a<44; a++) CopySprite_Palette(barre, sprite_decor_palette, 7*a-compteur%7+DECALAGE_SCREEN, 160, 7, 7);
			Rectangle(116+115*choix, 146, 153+115*choix, 156, COLOR_LIGHTSTEELBLUE*((compteur%24)<=11)+COLOR_WHITE*((compteur%24)>=12));
			CL_Filled_Rectangle(0, 0, 41, 216, COLOR_BLACK);
			CL_Filled_Rectangle(342, 0, 384, 216, COLOR_BLACK);
			Bdisp_PutDisp_DD();
		}
		while(key_down(key));
		if(exit==1)
		{
			if(choix==0)//game
			{
				score=0, key=0, passe=0;
				/*** tuto ***/
				while(passe==0)
				{
					key=GetKeyNB();
					if((key==K_EXE) || (key==K_SHIFT)) passe=1;
					if(key==K_EXIT) passe=2;
					if(compteur>48) compteur=0;
					compteur++;
					CopySprite_Palette(fond, fond_palette, DECALAGE_SCREEN, 0, SCREEN_LARGEUR, 216);
					CopySprite_Palette_Alpha(get_ready, sprite_menu_palette, 149, 60, 87, 22);
					print_score(score);
					CopySprite_Palette_Alpha(tuto, sprite_menu_palette, 173, 100, 38, 49);
					CopySprite_Palette_Alpha(sprite_bird[3*Nombre_oiseau+table[(compteur/2)%4]], sprite_bird_palette[3*Nombre_oiseau+table[(compteur/2)%4]], 130, 100, 17, 12);
					for(a=0; a<44; a++) CopySprite_Palette(barre, sprite_decor_palette, 7*a-compteur%7+DECALAGE_SCREEN, 160, 7, 7);
					CL_Filled_Rectangle(0, 0, 41, 216, COLOR_BLACK);
					CL_Filled_Rectangle(342, 0, 384, 216, COLOR_BLACK);
					Bdisp_PutDisp_DD();
				}
				while(key_down(key));
				if(passe==1)
				{
					/*** jeu ***/
					score=game(Nombre_oiseau);
					/*** score ***/
					view_score(best_score, score, MAKE);
					//enregistre score
					if((score>=10) && (score<20))
					{
						CopySprite_Palette_Alpha(medaille_4, sprite_menu_palette, 148, 121, 22, 22);
					}
					if((score>=20) && (score<30))
					{
						CopySprite_Palette_Alpha(medaille_3, sprite_menu_palette, 148, 121, 22, 22);
					}
					if((score>=30) && (score<50))
					{
						CopySprite_Palette_Alpha(medaille_2, sprite_menu_palette, 148, 121, 22, 22);
					}
					if(score>=50)
					{
						CopySprite_Palette_Alpha(medaille_1, sprite_menu_palette, 148, 121, 22, 22);
					}
					if(best_score<=score)
					{
						best_score=score;
						CopySprite_Palette(sprite_new, sprite_menu_palette, 202, 129, 16, 7);
					}
					Bdisp_PutDisp_DD();
					CopySprite_Palette(ok, sprite_menu_palette, 172, 175, 40, 14);
					key=0;
					while(key==0)
					{
						key=GetKeyNB();
					}
				}
			}
			if(choix==1)//tableau score
			{
				CopySprite_Palette(fond, fond_palette, DECALAGE_SCREEN, 0, SCREEN_LARGEUR, 216);
				CopySprite_Palette_Alpha(title, sprite_menu_palette, 144, 60, 96, 22);
				view_score(best_score, score, VIEW);
				for(a=0; a<44; a++) CopySprite_Palette(barre, sprite_decor_palette, 7*a-compteur%7+DECALAGE_SCREEN, 160, 7, 7);
				CL_Filled_Rectangle(0, 0, 41, 216, COLOR_BLACK);
				CL_Filled_Rectangle(342, 0, 384, 216, COLOR_BLACK);
				Bdisp_PutDisp_DD();
				Key_Down_Up(K_EXE);
			}
		}
	}
	return best_score;
}

int main(void)
{
	int initial_freq, data=0;
	srand(time_getTicks());
	Bdisp_AllClr_VRAM();
	initial_freq = (*((volatile unsigned int*)0xA4150000) & 0x3F000000) >> 24;
	if((initial_freq < PLL_26x) && (IsEmulated()==CALCULATRICE)) overclock(PLL_26x);
	data=save_read(sizeof(data));
	data=menu(data);
	save_write(data);
	overclock(initial_freq);
	return 0;
}
